/*!   Object constructor;
 *  targetDoc   : document name of the browser
 *  targetObject: object name of the object used as target of events
 *  callbackFunc: function to call for callbacks
 *  [_eventName]: name of the event wich is called when msg X>H
 *  [_listenerName]: name of the event wich is called when msg H>X
 */
function communicatorX2H(targetDoc, targetObject, callbackFunc, _eventName, _listenerName) {
  this.callbacks = new Array();
  this.eventName = (_eventName) ? _eventName : "communicatorX2H-evt";
  this.listenerName = (_listenerName) ? _listenerName : "communicatorH2X-evt";
  this.target = document.getElementById(targetDoc);
  this.targetObj = targetObject;
  
  document.addEventListener(this.listenerName, callbackFunc, false, true);
}

communicatorX2H.prototype = {
  callback : function(evt) {
    var type = evt.target.getAttribute("type");
    
    if(this.callbacks[type])
      this.callbacks[type](evt.target);
  },

  addCallback : function(typeName, callback) {
    this.callbacks[typeName] = callback;
  },
  
  send : function(type) { //type, objectName1, objectValue1, ..., objectNn, objectVn
    var doc = this.target.contentDocument;
    var elm = doc.getElementById(this.targetObj);

    if (elm && "createEvent" in doc) {
      elm.setAttribute("type", type);

      for(var i = 1; i < arguments.length - 1; i+=2) {
        elm.setAttribute(arguments[i], arguments[i+1]);
      }

      var evt = doc.createEvent("Events");
      evt.initEvent(this.eventName, true, false);
      elm.dispatchEvent(evt);
    }
  }
};
