Components.utils.import("resource://papaya/xmpp.jsm");

function inheritPrototype(parent, child) {
  for(let key in parent.prototype) {
    if(!child.prototype[key])
      child.prototype[key] = parent.prototype[key]
  }
}

function papayaAtomSidebarElm() {
  dump("this is a virtual class!\n");
}
papayaAtomSidebarElm.prototype = {
  sidebarBefore : 0,
  sidebarObject : 0,
  sidebarElementName : "contact-tab",
  muc : false,

  sidebarMake : function(id, name, infos, img, clickFunc) {    
    if(this.sidebarObject) return;

    let elm = document.createElement(this.sidebarElementName);
    this.sidebarObject = elm;

    papayaRoster.sidebarList.appendChild(elm);

    if(id)        elm.setAttribute("id", id);
    if(name)      this.sidebarSetName(name);
    if(infos)     this.sidebarSetInfos(infos)
    if(img)       this.sidebarSetImage(img);

    elm.addEventListener("mouseup", function(event){ if(event.button == 0){ clickFunc(event); papayaUI.popPopup();} }, false);
    papayaContextContact.attachEvent(this, this.sidebarObject, name, this.sidebarElementName);
  },
  
  sidebarRemove : function() {
    if(this.sidebarObject) {
      let id = this.sidebarObject.getAttribute("id")
      papayaRoster.sidebarList.removeChild(this.sidebarObject);
      this.sidebarObject = 0;
      this.sidebarBefore = 0;
    }
  },

  sidebarPut : function(after, top) {
    if(after) {
      if(top && papayaRoster.separatorObject.nextSibling)      
        papayaRoster.sidebarList.insertBefore(this.sidebarObject, papayaRoster.separatorObject.nextSibling);
      else         
        papayaRoster.sidebarList.appendChild(this.sidebarObject);
    }
    else if(!this.sidebarBefore)
              papayaRoster.sidebarList.insertBefore(this.sidebarObject, papayaRoster.separatorObject);
    this.sidebarBefore = !after;
  },

  sidebarSetName: function(value){
    if(this.sidebarObject)
      this.sidebarObject.setAttribute("name",  value);
  },
  sidebarSetImage: function(value){
    if(this.sidebarObject) {
      this.sidebarObject.setAttribute("image", value);
      this.sidebarObject.setAttribute("hidden-image",  (value.length)? false : true);
    }
  },
  sidebarSetInfos: function(value){
    if(this.sidebarObject){
      this.sidebarObject.setAttribute("infos", value);
      this.sidebarObject.setAttribute("hidden-infos",  (value.length)? false : true);
    }
  }
};

function papayaAtomListElm() {
  dump("this is a virtual class!\n");
}
papayaAtomListElm.prototype = {
  listObject : 0,
  listElementName : "contact",
  listParentObject : 0,

  listMake : function(parentObject, name, jid, infos, img) {
    let elm;
    elm = document.createElement(this.listElementName);
    this.listObject = elm;
    this.listParentObject = parentObject;
    parentObject.appendChild(elm);
    
    if(name)  elm.setAttribute("name", name);
    if(jid)   elm.setAttribute("jid", jid);
    if(infos) elm.setAttribute("infos", infos);
    if(img)   this.listSetImage(img);
  },

  listRemove : function() {
    if(this.listObject) {
      this.listParentObject.removeChild(this.listObject);
      this.listObject = undefined;
    }
  },

  listSetImage :  function(value) { if(this.listObject){ 
                                      this.listObject.setAttribute("image", value);
                                      this.listObject.setAttribute("hidden-image",  (value.length)? false : true);
                                    }
                                  },
  listSetName :   function(value) { if(this.listObject) this.listObject.setAttribute("name", value); },
  listSetJID :    function(value) { if(this.listObject) this.listObject.setAttribute("jid", value); },
  listSetInfos :  function(value) { if(this.listObject) this.listObject.setAttribute("infos", value); },
}

function papayaAtomAddElementsElm() {
  dump("this is a virtual class!\n");
}
papayaAtomAddElementsElm.prototype = {
  elmElements : 0,

  elmInit : function() {
    this.elmElements = new Array();
  },

  elmGet : function(name) {
    return this.elmElements[name];
  },

  elmSet : function(name, elm) {
    this.elmElements[name] = elm;
    return this.elmElements[name];
  },
  
  elmRemove : function(name) {
    delete this.elmElements[name];
    this.elmElements.splice(name, 1);
  },

  //set a prototype as "elm"
  elmCreateFrom : function(name, elm) {
    this.elmElements[name] = new elm();
    return this.elmElements[name];
  },
}

function papayaResource(parent, fullJID, resource, priority) {
  this.fullJID = fullJID;
  this.resource = resource;
  this.parent = parent;
  if(priority) this.priority = priority;
  
  //this.elmInit();
}
papayaResource.prototype = {
  parent : 0,
  fullJID : 0,
  resource : 0,
  priority : 0,
};
//~ inheritPrototype(papayaAtomAddElementsElm, papayaResource);

function papayaContact(bareJID, name, groups) {
  this.bareJID = bareJID;
  this.name = name;
  this.resources = new Array();

  if(groups)  this.setGroups(groups);

  this.elmInit();
  this.mainResource = this.setResource(bareJID, "", -150);
}
papayaContact.prototype = {
  bareJID : 0,
  name : 0,
  avatar : 0,
  resources : 0,
  groups : 0,
  mainResource : 0,
  mainResourceMode : 0, //0: nothing done, 1: last message received, 2: user force one fullJID
  persist : 0,

  makeDom : function() {
    this.listMake(papayaRoster.contactsList, this.name, this.bareJID, this.avatar);
    this.setGroups(this.groups);
  },
  
  delete : function() {
    this.sidebarRemove();
    this.listRemove();
  },

  /*  Sidebar
   */
  setPersist : function(value) {
    this.persist = value;
    prefManager.setPref('papaya.contacts.'+this.bareJID+'.show', value);

    if(this.listObject)
      this.listObject.checked = value;

    if(value && !this.sidebarObject)
      this.putSidebar(true);
    else 
    if(!value && this.sidebarObject && !this.sidebarBefore)
        this.removeSidebar();
  },

  putSidebar : function(after, top) {
    if(!this.sidebarObject) {
      this.mainResource = this.getBestPriority(); //FIXME

      this.sidebarMake(this.bareJID, this.name, 
        0, this.avatar,
        function(evt){ papayaChat.switchToElement(evt.currentTarget.getAttribute("id")) }
      );
    }
    this.sidebarPut(after, top);
  },

  removeSidebar : function(verifPersist) {
    if(verifPersist && this.persist) {
      this.putSidebar(true);
      papayaUI.alert(0, "Close this discussion", "Because he is persist, this contact stays at the bottom of the sidebar");
      return;
    }

    this.sidebarRemove();
    papayaChat.removeElement(this);
  },
  
  /*  Contact informations
   */
  setNick : function(value) {
    this.name = value;
    this.sidebarSetName(value);
    this.listSetName(value);
  },

  setAvatar : function(value) {
    this.avatar = value;

    this.sidebarSetImage(value);
    this.listSetImage(value);

    //~ if(aId) prefManager.setPref("papaya.contacts."+this.bareJID+".avatar.id", aId);
  },

  setGroups : function(value) {
    this.groups = value;

    if(this.listObject) {
      let str = "";    
      if(value.length) {
        let i = 0;
        for(; i < value.length - 1; ++i)
          str += value[i] + ", ";
        str += value[i];
      }
      this.listSetInfos(str);
    }
  },

  /*  Managing resources
   */
  getResource : function(fullJID) {
    return this.resources[fullJID];
  },
  
  setResource : function(fullJID, resource, priority) {
    let res = this.resources[fullJID];

    if(!res) {
      res = new papayaResource(this, fullJID, (resource) ? resource : papayaStr.getResource(fullJID), priority);
      this.resources[fullJID] = res;
    }
    if(priority) res.priority = priority;

    return res;
  },

  removeResource : function(fullJID) {
    if(fullJID == this.bareJID) return;
    
    let resource = this.resources[fullJID];
    if(!resource)   return;

    this.resources.splice(fullJID, 1);
  },

  clearResource : function() {
    this.resources.splice(1, this.resources.length); //FIXME: is it the good solution?
  },
  
  getBestPriority : function() {
    let last = -150;
    let lastObj = this.resources[this.bareJID];
    for(var i in this.resources)
      if(this.resources[i].priority > last) {
        lastObj = this.resources[i];
        last = lastObj.priority;
      }
    return lastObj;
  },

  getDstJID : function() {
    return this.mainResource.fullJID;
  },
};
inheritPrototype(papayaAtomSidebarElm, papayaContact);
inheritPrototype(papayaAtomListElm, papayaContact);
inheritPrototype(papayaAtomAddElementsElm, papayaContact);


var   papayaRoster = {  
  contactList : new Array(),
  mucList : new Array(),
  mucXML : 0,

  /* Dom objects */
  //Sidebar
  sidebarList : 0,
  sidebarRichlistBox : 0,
  separatorObject : 0,
  scrollerSidebar : 0,
  //Contact list
  contactsList : 0,
  scrollerContactsList : 0,
  //Muc list
  mucsList : 0,
  scrollerMucsList : 0,
  mucContactsList : 0,
  scrollerMucContactsList : 0,

  /* User informations */
  myInfos : 0,

  /** XMPP
   */
  setXMLPresence : function(xml) {
    let jid = papayaStr.getBareJID(xml.@from.toString());
    let obj = this.mucList[jid];

    if(obj) {
      var fjid = (xml..ns_muc_user::item) ? xml..ns_muc_user::item.@jid : xml.@from.toString();
      obj.add(fjid, xml.@from.toString(), papayaStr.getResource(xml.@from.toString()));

      papayaChat.putInMucMsg(obj, jid, xml.@from.toString().substr(jid.length + 1) + " has joined the room");
    }
    else
      this.setResource(xml.@from.toString(), (xml..priority) ? parseInt(xml..priority) : 0);
  },

  removePresence : function(jid) {
    let bareJID = papayaStr.getBareJID(jid);
    let obj = this.mucList[bareJID];

    if(obj) {
      papayaChat.putInMucMsg(papayaChat.getElement(bareJID), bareJID, papayaStr.getResource(jid) + " has left the room");
      obj.remove(jid);
    }
    else
      this.removeResource(jid);
  },

  returnPresence : function(jid) {
    let bareJID = papayaStr.getBareJID(jid);
    let obj = this.mucList[bareJID];

    if(obj) { //FIXME TH: probable bug when is the muc jid only
      if(jid == bareJID) return obj;

      var elm = obj.get(jid);
      if(!elm)
        elm = obj.add(jid, jid, papayaStr.getResource(jid));
      return elm;
    }
    return this.set(bareJID);
  },

  getPresence : function(jid) {
    let bareJID = papayaStr.getBareJID(jid);
    let obj = this.mucList[bareJID];

    if(obj) { //FIXME TH: probable bug when is the muc jid only
      if(jid == bareJID) return obj;
      return obj.get(jid);
    }
    return this.get(bareJID);
  },

  setAvatar : function(jid, value) {
    let bareJID = papayaStr.getBareJID(jid);
    let obj = this.mucList[bareJID];

    if(bareJID == this.myInfos.bareJID) {
      this.setMyAvatar(value);
      return;
    }

    if(obj) {
      let elm = obj.get(jid);
      if(!elm)
        return;

      elm.setAvatar(value);
    }
    else {
      let contact = this.contactList[bareJID];
      if(contact)
        contact.setAvatar(value);
    }
  },
  
  clearAll : function() {
    this.clear();
    this.clearMuc();
  },

  /** Contacts
   */
  addContactXML : function(xml) {
    //TODO: nick
    let item = xml::ns_roster..item;
    let groups = 0;

    if(item..ns_roster::group) {
      groups = new Array();
      groupXml = item..ns_roster::group;
      if(groupXml.length()) {
        for(j = 0; j < groupXml.length() - 1; ++j)
          groups[j] = groupXml[j].toString();
        groups[j] = groupXml[j].toString();
      }
      else
        groups[0] = groupXml.toString();
    }
    
    this.add(item.@jid, papayaStr.getName(item.@jid.toString()), groups);
  },
  
  removeContactXML : function(xml) {
    let item = xml::ns_roster..item;
    this.remove(item.@jid);
  },
  
  add : function(bareJID, nickname, groups) {
    let contact = this.contactList[bareJID];

    if(contact) {
      if(contact.name != nickname && nickname)
        contact.setNick(nickname);
      if(groups)
        contact.setGroups(groups);

      return contact;
    }
    
    contact = new papayaContact(bareJID, nickname, groups);
    this.contactList[bareJID]  = contact;
    return contact;
  },
  
  clear : function() {
    for(let key in this.contactList) {
      this.contactList[key].delete();
      this.contactList[key] = undefined;
    }
  },
  
  remove : function(bareJID) {
    let contact = this.contactList[bareJID];
    if(contact) {
      contact.delete();
      this.contactList.splice(bareJID, 1);
      delete contact;
    }
  },
  
  set : function(bareJID) {
    let contact = this.contactList[bareJID];
    if(contact) 
      return contact;

    return this.add(bareJID, papayaStr.getName(bareJID), "");
  },

  get : function(value) {
    return this.contactList[value];
  },

  getResource : function(fullJID) {
    let contact = this.contactList[papayaStr.getBareJID(fullJID)];
    if(contact)
      return contact.getResource(fullJID);

    return 0;
  },
  
  setResource : function(fullJID, priority, name) {
    let bareJID = papayaStr.getBareJID(fullJID);
    let contact = this.contactList[bareJID];

    if(!contact) {
      contact = this.add(bareJID, (name) ? name : papayaStr.getName(bareJID));
      return contact.setResource(fullJID, fullJID.substr(bareJID.length + 1), priority);
    }
    return contact.setResource(fullJID, fullJID.substr(bareJID.length + 1), priority);
  },
  
  removeResource : function(fullJID) {
    let bareJID = papayaStr.getBareJID(fullJID);
    let contact = this.contactList[bareJID];
    if(contact)      contact.removeResource(fullJID);
  },

  setNick : function(bareJID, value) {
    if(value.length == 0)    return;

    if(bareJID == this.myInfos.bareJID) {
      this.setMyNickInternal(value);
      return;
    }
      //can have contact in the list wich is the user (under
      //one another resource)

    let contact = this.contactList[bareJID];
    if(contact)
      contact.setNick(value);
  },

  loadRoster : function(roster) {
    let item, contact;
    let groups, groupXml;
    let j, name;
    this.requestRoster = true;

    var sortedArray = new Array();

    this.clear();

    for(let i = 0; i < roster.length(); ++i) {
      if(roster[i].@jid.toString().length) {
        item = roster[i];
        groups = new Array();

        if(item..ns_roster::group) {
          groupXml = item..ns_roster::group;
          if(groupXml.length()) {
            for(j = 0; j < groupXml.length() - 1; ++j) {
              groups[j] = groupXml[j].toString();
            }
            groups[j] = groupXml[j].toString();
          }
          else
            groups[0] = groupXml.toString();
        }
        let name = item.@name.toString();
        let jid = item.@jid.toString();
        if((name == jid)||(name.length == 0))
          name = papayaStr.getName(jid);
        contact = this.add( jid, name, groups);
        contact.sidebarObject = (prefManager.getPref('papaya.contacts.'+jid+'.show')) ? 1 : 0;
        
        sortedArray.push({name: name, jid: jid});
      }
    }
    this.add(this.myInfos.bareJID, this.myInfos.name);
    
    sortedArray.sort(function(a, b) {
      return papayaStr.strCmp(a.name, b.name); 
    });

    var value;
    for(let key in sortedArray) {
      contact = this.contactList[sortedArray[key].jid]
      contact.makeDom();
      if(contact.sidebarObject) {
        contact.sidebarObject = 0;
        contact.setPersist(true);
      }
      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account) == true)
          XMPP.send(account, vCard.get(account.address, contact.bareJID));
      });
    }
    
    XMPP.accounts.forEach(function(account) {
    if(XMPP.isUp(account) == true)
      XMPP.send(account, vCard.get(account.address, account.address));
    });
    this.loadMucs();
  },

  filterContactsList : function(str) {
    this.filter(this.contactsList, this.scrollerContactsList, str);
  },

  /** Mucs
   */
  getMuc : function(jid) {
    return this.mucList[jid];
  },
  
  getMucContact : function(jid) {
    let obj = this.mucList[papayaStr.getBareJID(jid)];
    
    if(obj)
      return obj.get(jid);
    return null;
  },
  
  addMuc : function(jid, name, nickname, notbookmark) {
    let elm = new papayaMuc(jid, name, nickname, notbookmark);
    this.mucList[jid] = elm;
    return elm;
  },
  
  clearMuc : function() {
    for(var key in this.mucList) {
      this.mucList[key].delete();
      this.mucList[key] = undefined;
    }
  },
  
  removeMuc : function(jid) {
    let obj = this.mucList[jid];
    
    if(!obj) return;
    
    obj.delete();
    this.mucList.splice(jid, 1);
    delete obj;
  },
  
  setMuc : function(jid) {
    let muc = this.getMuc(jid);
    if(!muc) this.addMuc(jid, papayaStr.getName(jid));
    return muc;
  },
  
  loadMucs : function(_bookmarks) {
    if(!_bookmarks) {
      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account))
          XMPP.send(account, bookmarks.get());
      });
      return;
    }

    let object;
    let name;
    let jid;
    if(_bookmarks.length())
      for(var i in _bookmarks) {
        jid = _bookmarks[i].@jid.toString();

        if(!jid.length || this.mucList[jid]) continue;

        name = (_bookmarks[i].@name) ? _bookmarks[i].@name.toString() : papayaStr.getName(jid);
        object = new papayaMuc( jid, name, (_bookmarks[i]..name) ? _bookmarks[i]..name.toString() : 0);

        this.mucList[jid] = object;
      }
    else {
      jid = _bookmarks[i].@jid.toString();
      if(jid.length && !this.mucList[jid]) {
        name = (_bookmarks.@name) ? _bookmarks.@name.toString() : papayaStr.getName(jid);
        object = new papayaMuc( jid, name);

        this.mucList[jid] = object;
      }
    }

    this.mucXML = _bookmarks;
  },

  //~ filterMucsList : function(str) {
    //~ this.filter(this.mucsList, this.scrollerMucsList, str);
  //~ },

  filterMucContactsList : function(str) {
    this.filter(this.mucContactsList, this.scrollerMucContactsList, str);
  },

  /** Personnal informations
   */
  setMyNick : function(nickname) {
    this.myInfos.setNick(nickname);
    document.getElementById("papaya-profile-nick").value = nickname;
    XMPP.accounts.forEach(function(account) {
      if(XMPP.isUp(account) == true){
        XMPP.send(account, nick.publish(account.address, nickname));
      }
    });
  },
  
  setMyAvatar : function(avatar) {
    this.myInfos.setAvatar(avatar);
    //CHANGE button here
    document.getElementById("papaya-avatar").setAttribute("src", avatar);
  },
  
  setMyNickInternal : function(nickname) {
    this.myInfos.name = nickname;
    document.getElementById("papaya-profile-nick").value = nickname;
  },
  
  isConnected : function() {
    for(let i in XMPP.accounts)
      if(XMPP.isUp(XMPP.accounts[i]) == true)
        return true;
    return false;
  },

  /** Object & Misc
   */
  filter : function(object, scroller, str) {
    let elm;

    if(str.length == 0)
      for(let i=0; i < object.childNodes.length; ++i)
        object.childNodes[i].setAttribute("hidden", "false");
    else
      for(let i=0; i < object.childNodes.length; ++i) {
        elm = object.childNodes[i];

        if(elm.isSubString(str))
          elm.setAttribute("hidden", "false");
        else
          elm.setAttribute("hidden", "true");
      }
    if(object.childNodes[0])
      scroller.scrollToElement(object.childNodes[0]);
  },

  init : function() {
    let bareJID = prefManager.getPref("xmpp.account.papaya.address");
    let nick = papayaStr.getName(bareJID);

    this.myInfos = this.add(bareJID, nick);
    this.setMyNickInternal(nick);
    this.myInfos.setResource(bareJID + "/" + prefManager.getPref("xmpp.account.papaya.address"), prefManager.getPref("xmpp.account.papaya.address"));
    this.myInfos.setAvatar("chrome://papaya/skin/papaya.png");

    this.separatorObject = document.getElementById("papaya-sidebar-separator");
    this.sidebarList = document.getElementById("papaya-sidebar-list");
    this.sidebarRichlistBox = document.getElementById("papaya-sidebar-tabs");
    this.contactsList = document.getElementById("papaya-contacts");
    this.mucsList = document.getElementById("papaya-bookmarks");
    this.mucContactsList = document.getElementById("papaya-muc-contacts");

    this.scrollerContactsList = document.getElementById("papaya-contacts-list-scrollbox").
                                  boxObject.QueryInterface(Components.interfaces.nsIScrollBoxObject);
    this.scrollerSidebar = document.getElementById("papaya-sidebar").
                              boxObject.QueryInterface(Components.interfaces.nsIScrollBoxObject);
    this.scrollerMucsList = document.getElementById("papaya-mucs-list-scrollbox").
                                  boxObject.QueryInterface(Components.interfaces.nsIScrollBoxObject);
    this.scrollerMucContactsList = document.getElementById("papaya-muc-contacts-list-scrollbox").
                                  boxObject.QueryInterface(Components.interfaces.nsIScrollBoxObject);
  }
};

var   papayaRosterUI = {
  closeTab : function(elm) {
    elm.removeSidebar(true);
  },

  listedContactsMuc : 0,
  showContactsMuc : function(muc) {
    //TODO: auto update when a new contact arrive in the MUC
    if(papayaUI.isVisible("papaya-contacts-muc-contacts-container"))
      papayaUI.setPanel("papaya-im-container");
    else {
      papayaUI.setPanel("papaya-contacts-muc-contacts-container");
      papayaRoster.filterMucContactsList('');

      let key;
      if(this.listedContactsMuc) {
        let list = this.listedContactsMuc.list;
        for(key in list)
          list[key].listRemove();
      }
      
      for(key in muc.list)
        muc.list[key].makeList();
    }
  },

  showResources : function(contact) {
    let list = document.getElementById("papaya-resources-commands");
    let item;
    while(list.childNodes.length > 1) {
      item = list.removeChild(list.childNodes[1]);
      delete item;
    }

    if(!contact.resources) {
      papayaUI.alert(0, "Show resources", "This contact comes from a chat room");
      papayaUI.popPopup();
      return;
    }

    list.childNodes[0].setAttribute("jid", contact.bareJID);

    let elm;
    for(let key in contact.resources) {
      elm = contact.resources[key];

      item = document.createElement("richlistitem");
      item.setAttribute("jid", elm.fullJID);
      item.appendChild(document.createElement("label")).setAttribute("value", (elm.resource) ? elm.resource : "Default");
      list.appendChild(item);

      item.addEventListener("click", function(evt) {
        //~ document.getElementById("papaya-resources-popup").hidden = true;
        papayaUI.popPopup();
        let res = papayaRoster.getResource(evt.currentTarget.getAttribute("jid"));
        if(!res)
          return;
        
        res.parent.mainResource = res;
        res.parent.mainResourceMode = 2;
      }, false);
    }
    papayaUI.pushPopup(document.getElementById("papaya-resources-popup"));
  },


};

var papayaContextContact = {
  currentElement : 0,
  
  hide : function() {
    papayaUI.popPopup();
  },
  
  showContext : function(elm, title, type) {
    this.currentElement = elm;
    document.getElementById("papaya-context-contacts-hint").value = title;
      
    //Adapted from the Fennec Code
    let commands = document.getElementById("papaya-context-contacts-commands");
    let first = null;
    let last = null;
    for(let i = 0; i < commands.childElementCount; ++i) {
      let command = commands.children[i];
      command.removeAttribute("selector");
      
      if(command.getAttribute("type") != type)
        command.hidden = true;
      else {
        command.hidden = false;
        if(!first) first = command;
        last = command;
      }
    }
    
    if(!first)        return false;
    first.setAttribute("selector", "first-child");
    last.setAttribute("selector", "last-child");
    
    let container = document.getElementById("papaya-context-contacts-popup");
    papayaUI.pushPopup(container);
      
    return true;
  },
  
  attachEvent : function(elm, object, title, type) {
    object.addEventListener("contextmenu", function(evt) {
      papayaContextContact.showContext(elm, title, type);
    }, false);
  }
};
