Components.utils.import('resource://papaya/string.jsm');
Components.utils.import('resource://papaya/xmpp.jsm');

//TODO: nickname error

function papayaMucContact(parent, fullJID, mucJID, nick) {
  this.fullJID = fullJID;
  this.mucJID = mucJID;
  this.name = nick;
  this.parent = parent;
  this.listElementName = "muc-contact-roster";
  this.sidebarElementName = "contact-tab";
  this.elmInit();
}
papayaMucContact.prototype = {
  //TODO: resource
  fullJID : 0,
  mucJID : 0,
  name : 0,
  avatar : "chrome://papaya/skin/anonym.png",
  parent : 0,

  getDstJID : function() {
    return this.fullJID;
  },

  setAvatar : function(value) {
    this.avatar = value;
    this.sidebarSetImage(value);
  },
  setNick : function(value) {
    this.name = value;
    this.sidebarSetName(value);
  },
  
  delete : function() {
    this.sidebarRemove();
    this.listRemove();
  },
  
  /*  Sidebar
   */
  switchSidebar : function() {
    if(!this.sidebarObject)
      this.putSidebar(true);
    else
      this.removeSidebar();
  },

  putSidebar : function(after, top) {
    this.sidebarMake(this.mucJID, this.name, "Room " + this.parent.jid, this.avatar,
      function(evt){ papayaChat.switchToElement(evt.currentTarget.getAttribute("id")) }
    );

    this.sidebarPut(after, top);
  },
  
  removeSidebar : function() {
    this.sidebarRemove();
    papayaChat.removeElement(this);
  },

  /*  List:
   */
  makeList : function() {
    this.listMake(papayaRoster.mucContactsList, this.name, this.mucJID);
  }
};
inheritPrototype(papayaAtomSidebarElm, papayaMucContact);
inheritPrototype(papayaAtomListElm, papayaMucContact);
inheritPrototype(papayaAtomAddElementsElm, papayaMucContact);

function papayaMuc(jid, name, nickname, notbookmark) {
  this.jid = jid;
  if(!name) this.name = papayaStr.getName(jid);
  else      this.name = name;
  if(nickname) this.nickname = nickname;

  this.list = new Array();

  this.sidebarElementName = "groupchat-tab";
  this.listElementName = "bookmark";
  this.muc = true;

  this.elmInit();
  
  if(!notbookmark)
    this.listMake(papayaRoster.mucsList, name, jid);
}

papayaMuc.prototype = {
  list : 0,
  open : false,

  jid : 0,
  name : 0,
  autoJoin : 0,
  nickname : 0,

  getDstJID : function() {
    return this.jid;
  },

  delete : function() {
    this.leaveMuc();
    this.sidebarRemove();
    this.listRemove();
  },

  switchSidebar : function() {
    if(!this.sidebarObject)
      this.putSidebar(true);
    else
      this.removeSidebar();
  },

  putSidebar : function(after, top) {    
    this.sidebarMake(this.jid, this.name, this.jid, 0, 
      function(evt){ papayaRoster.getMuc(evt.currentTarget.getAttribute("id")).openMuc(); }
    );

    this.sidebarPut(after, top);
  },
  
  removeSidebar : function() {
    this.leaveMuc();
    this.sidebarRemove();
    papayaChat.removeElement(this);
  },

  /*  Muc Session
   */
  openMuc : function() {
    if(!this.open) {
      if(!this.sidebarObject)   this.putSidebar();

      var jid = this.jid;
      var nick = (this.nickname) ? this.nickname : papayaRoster.myInfos.name;
      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account)) {
          XMPP.send(account, muc.join(jid, nick));
        }
      });
      this.open = true;
    }
    papayaChat.switchToElement(this.jid);
  },
  
  leaveMuc : function() {
    if(this.open) {
      var jid = this.jid;
      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account))
          XMPP.send(account, muc.leave(account.address, jid));
      });

      this.open = false;

      for(var key in this.list) {
        this.list[key].delete();
        this.list[key] = undefined;
      }
    }
  },
  
  /*  Members
   */
  get : function(fjid) {
    return this.list[fjid];
  },
  
  add : function(fjid, mucjid, nick) { //FIXME TH: keep difference between mucjid & fjid?
    var obj = this.list[mucjid];
    if(obj) {
      if(nick) obj.setNick(nick);
    }
    else {
      obj = new papayaMucContact(this, fjid, mucjid, nick);
      this.list[mucjid] = obj;
    }

    XMPP.accounts.forEach(function(account) {
      if(XMPP.isUp(account) == true)
        XMPP.send(account, vCard.get(account.address, mucjid));
    });
      
    return obj;
  },

  remove : function(fjid) {
    var obj = this.list[fjid];
    if(!obj)  return;

    obj.delete();
    this.list[fjid] = undefined;
  }
};
inheritPrototype(papayaAtomSidebarElm, papayaMuc);
inheritPrototype(papayaAtomListElm, papayaMuc);
inheritPrototype(papayaAtomAddElementsElm, papayaMuc);

var papayaXmppMuc = {
  //~ add : function(){
    //~ //TODO: dialog in state of prompt (thomas)
    //~ var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                            //~ .getService(Components.interfaces.nsIPromptService);
    //~ var check = {value: true};
    //~ var input = {value: ""};
    //~ var result = prompts.prompt(null, "Add a conference", "Enter a conference address", input, "Auto-join", check);
//~ 
    //~ if(result == true) {
      //~ var input2 = {value: papayaStr.getName(input.value)};
      //~ result = prompts.prompt(null, "Add conference", "Enter a name for the conference", input2, null, check);
      //~ 
      //~ if(!result) return;
//~ 
      //~ XMPP.accounts.forEach(function(account) {
        //~ if(XMPP.isUp(account) == true){
          //~ XMPP.send(account, bookmarks.add(account.address, input.value, input2.value, check.value, papayaRoster.mucList));
        //~ }
      //~ });
//~ 
      //~ papayaRoster.addMuc(input.value, input2.value);
    //~ }
  //~ },
  add : function(){
    importDialog(null, "chrome://papaya/content/addconference.xul");
  },
  join : function(){
    importDialog(null, "chrome://papaya/content/joinconference.xul");
  },

  remove : function(fjid){
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                            .getService(Components.interfaces.nsIPromptService);
    var result = prompts.confirm(null, "Delete conference", "Are you sure to remove " + fjid + " from yours bookmarks?");
    
    if(result) {
      papayaRoster.removeMuc(fjid);

      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account) == true){
          XMPP.send(account, bookmarks.remove(account.address, fjid, papayaRoster.mucList));
        }
      });
    }
  },

};
