var papayaUI = {
  alertService : Components.classes["@mozilla.org/alerts-service;1"]
                 .getService(Components.interfaces.nsIAlertsService),

  setDisconnected : function() {
    var menulist = document.getElementById("papaya-identity-show");
    menulist.value = "offline";
  },

  setConnected : function() {
    var menulist = document.getElementById("papaya-identity-show");
    menulist.value = "online";
  },

  alert : function(image, title, text) {
    if(prefManager.getPref("papaya.ui.notifications") == true)
      this.alertService.showAlertNotification(image, title, text);
  },

  xmppconsoleWindow : function(){
    window.openDialog("chrome://xmppdev/content/console.xul");
  },
  
  /*  Stack
   */
  currentPopup : 0,
  popPopup : function() {
    if(this.currentPopup) {
      this.currentPopup.hidden = true;
      this.currentPopup = 0;
    }
  },
  
  pushPopup : function(container) {
    this.popPopup();
    this.currentPopup = container;
    
    //The code of this function until the next comment is taken
    //from the Fennec code
    container.hidden = false;

    let preferredHeight = 0;
    for (let i=0; i<container.childElementCount; i++) {
      preferredHeight += container.children[i].getBoundingClientRect().height;
    }

    let rect = container.getBoundingClientRect();
    let height = Math.min(preferredHeight, 0.75 * window.innerWidth);
    let width = Math.min(rect.width, 0.75 * window.innerWidth);

    container.height = height;
    container.width = width;
    container.top = (window.innerHeight - height) / 2;
    container.left = (window.innerWidth - width) / 2;
    //comment
  },

  /*  Panels
   */
  setPanel : function(id) {
    document.getElementById("papaya-panels").selectedPanel = document.getElementById(id);
  },
  
  isVisible : function(id) {
    if(id)
      return (document.getElementById("papaya-panels").selectedPanel.getAttribute("id") == id);
    else
      return (document.getElementById("panel-items").selectedPanel.getAttribute("id") == "papaya-stack" &&
              BrowserUI.isPanelVisible());
  },
};

function updateUI() {
  if(XMPP.accounts.some(XMPP.isUp)){
    document.getElementById("papaya-container").selectedIndex = 1;
    document.getElementById("papaya-progressmeter").hidden = true;
  }
  else
    document.getElementById("papaya-container").selectedIndex = 0;
}
function papayaConnect() {
  XMPP.accounts.forEach(function(account) {
    XMPP.up(account, channels());
  });
  document.getElementById("papaya-progressmeter").hidden = false;
}

var handshake = {
  subscribeHandler : function(aFrom) {
    //FIXME
    if(papayaChat.isVisible() == false)
      papayaUI.alert("chrome://papaya/skin/warning.png", "Contact:", aFrom+" "+"wants subscribe to your presence");
    var notificationbox = document.getElementById("papaya-notificationbox");
    var buttons = [{
      label: "Accept",
      accessKey: null,
      popup: null,
      callback: function(aNotification) {
        XMPP.accounts.forEach(function(account) {
          if(XMPP.isUp(account))
            XMPP.send(account, presence.subscribed(aFrom));
        });
        handshake.add(aFrom);
        //~ presence.acceptSubscribe(aFrom);
        //~ notificationbox.removeNotification(aNotification);
      }
    },{
      label: "Refuse",
      accessKey: null,
      popup: null,
      callback: function(aNotification) {
        XMPP.accounts.forEach(function(account) {
          if(XMPP.isUp(account))
            XMPP.send(account, presence.unsubscribed(aFrom));
        });
      }
    }];
    notificationbox.appendNotification(aFrom+" wants know when you are connected.", "subscribe", null, "PRIORITY_INFO_MEDIUM", buttons );
  },
  add: function(aFrom) {
    var notificationbox = document.getElementById("papaya-notificationbox");
    var buttons = [{
      label: "Yes",
      accessKey: null,
      popup: null,
      callback: function(aNotification) {
        addContact(aFrom);
      }
    },{
      label: "No",
      accessKey: null,
      popup: null,
      callback: function(aNotification) {
        return;
      }
    }];
    notificationbox.appendNotification("Do you want add him/her to your contact list?", "add", null, "PRIORITY_INFO_MEDIUM", buttons );
  },
};

function addContact(aJid){
  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                          .getService(Components.interfaces.nsIPromptService);
  var check = {value: true};
  if(aJid && aJid.length)
    var input = {value: aJid};
  else
    var input = {value: ""};
  var result = prompts.prompt(null, "Add a contact", "Enter a Jabber address", input, "Subscribe his presence", check);
  if(result == true) {
    if(check.value == true) {
      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account))
          XMPP.send(account, roster.add(input.value));
      });
    }
    if(check.value == true) {
      XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account))
          XMPP.send(account, presence.subscribe(input.value));
      });
    }
  }
};
function deleteContact(bareJID){
  //! This function can just be called by the chat contact information banner !!!
  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);

  var jid;
  var result;
  
  if(bareJID)
    jid = bareJID;
  else
    jid = document.getElementById("papaya-im-contact-jid").value;

  result = prompts.confirm(null, "Delete contact", "Delete " + papayaRoster.get(jid).name + " (" + jid + ") from your roster?");
  
  if(result == true) {
    XMPP.accounts.forEach(function(account) {
        if(XMPP.isUp(account))
          XMPP.send(account, roster.remove(jid));
      });
      
    var aRoster = document.getElementById("contact-list");
    var list = document.getElementsByAttribute("barejid", jid);

    for(var i=0; i < list.length; ++i)
      roster.remove(list[i], document.getElementById("contact-list"));
  }
};


function filePicker(element){
  const nsIFilePicker = Components.interfaces.nsIFilePicker;

  var fp = Components.classes["@mozilla.org/filepicker;1"]
               .createInstance(nsIFilePicker);
  fp.init(window, "Dialog Title", nsIFilePicker.modeOpen);
  fp.appendFilters(nsIFilePicker.filterImages);

  var rv = fp.show();
  if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
    var aFile = fp.file;
    var aData = getFileData(aFile);
    var aType = getFileType(aFile);
    var time = new Date();
    var aId = time.getTime();
    //~ var dataURI = return "data:" + contentType + ";base64," + encoded;
    var stanza = <presence>
      <x xmlns={ns_vcard_update}><photo>{aId}</photo></x>
    </presence>;
    XMPP.accounts.forEach(function(account) {
      if(XMPP.isUp(account) == true){
        XMPP.send(account, vCard.set(aType, aData));
        XMPP.send(account, stanza);
      }
    });
  }
}

function getFileType(aFile) {
  var contentType = Components.classes["@mozilla.org/mime;1"]
                              .getService(Components.interfaces.nsIMIMEService)
                              .getTypeFromFile(aFile);
  return contentType;
}
function getFileData(aFile) {
  var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                              .createInstance(Components.interfaces.nsIFileInputStream);
  inputStream.init(aFile, 0x01, 0600, 0);
  var stream = Components.classes["@mozilla.org/binaryinputstream;1"]
                         .createInstance(Components.interfaces.nsIBinaryInputStream);
  stream.setInputStream(inputStream);
  var encoded = btoa(stream.readBytes(stream.available()));
  return encoded;
}
var avatar = {
  metadata: function(aJid) {
    XMPP.accounts.forEach(function(account) {
      if(XMPP.isUp(account) == true)
          XMPP.send(account, vCard.get(account.address, aJid));
    });
  },
  data: function(aJid, aData, aType) {
    papayaRoster.setAvatar(aJid, "data:"+aType+";base64,"+aData);
  }
};
window.addEventListener("load", program.init, true);
//FIXME disconnect
//~ window.addEventListener("unload", program.uninit, true);
