Components.utils.import("resource://papaya/namespaces.jsm");
var EXPORTED_SYMBOLS = ["_message","presence","contact","bookmarks","vCard","pubsub","PEP", "geoloc", "nick", "_avatar", "muc", "roster"];

var _message = {
  send: function (aTo, aMessage, aHTML, aType, aSubject) {
    var stanza;
    
    stanza =  <message to={aTo} type={aType}>
                <body>{aMessage}</body>
              </message>;
    if(aHTML)
      stanza.appendChild(
        new XML("<html xmlns='http://jabber.org/protocol/xhtml-im'><body xmlns='http://www.w3.org/1999/xhtml'>"+aHTML+ "</body></html>")
      );
    if(aSubject)
      stanza.appendChild(<subject>{aSubject}</subject>);

    return stanza;
  }
};
var presence = {
  set: function (aFrom, aShow, aStatus, aPriority) {
    var stanza =  <presence from={aFrom}>
                  </presence>;
    if(typeof(aShow) != "undefined")
      stanza.appendChild(<subject>{aShow}</subject>);
    if(typeof(aStatus) != "undefined")
      stanza.appendChild(<subject>{aStatus}</subject>);
    if(typeof(aPriority) != "undefined")
      stanza.appendChild(<subject>{aPriority}</subject>);
    return stanza;
  },
  subscribe : function(aTo) {
    return <presence to={aTo} type="subscribe"/>;
  },
  subscribed : function (aTo) {
    return <presence to={aTo} type="subscribed"/>;
  },
  unsubscribe : function (aTo) {
    return <presence to={aTo} type="unsubscribe"/>;
  },
  unsubscribed : function (aTo) {
    return <presence to={aTo} type="unsubscribed"/>;
  }
};
var bookmarks = {
  get : function(){
    return  <iq type="get">
              <query xmlns={ns_private}>
                <storage xmlns={ns_bookmarks}/>
              </query>
            </iq>;
  },

  add : function(aList) {
    var stanza =  <iq type="set">
                    <query xmlns={ns_private}>
                      <storage xmlns={ns_bookmarks}>
                        <item id='current'>
                        </item>
                      </storage>
                    </query>
                  </iq>;
    stanza..ns_bookmarks::item.appendChild(aList);
    //~ for(var i in list)
      //~ if(list[i].jid.length)
        //~ stanza..ns_bookmarks::item.appendChild(<conference name={list[i].name} autojoin={list[i].autoJoin} jid={list[i].jid}/>);

    return stanza;
  },
  //~ remove : function(aFrom, aJID, list) {
    //~ var result =  <iq from={aFrom} type="set">
                    //~ <query xmlns="jabber:iq:private">
                      //~ <storage xmlns="storage:bookmarks">
                      //~ </storage>
                    //~ </query>
                  //~ </iq>;
    //~ 
    //~ for(var i in list)
      //~ if(list[i].jid.length && list[i].jid != aJID)
        //~ result..ns_bookmarks::storage.appendChild(<conference name={list[i].name} autojoin={list[i].autoJoin} jid={list[i].jid}/>);
//~ 
    //~ return result;
  //~ }
};
var vCard = {
  get : function(aFrom, aTo){
    return  <iq type='get' from={aFrom} to={aTo}>
              <vCard xmlns={ns_vcard}/>
            </iq>;
  },
  set : function(aType, aData){
    return <iq type='set'>
            <vCard xmlns='vcard-temp'>
              <PHOTO>
                <TYPE>{aType}</TYPE>
                <BINVAL>{aData}</BINVAL>
              </PHOTO>
            </vCard>
          </iq>;
  }
};
var pubsub = {
  stanza : function (aFrom, aType, aXmlns, aStanza) {
     return <iq from={aFrom} type={aType}><pubsub xmlns={aXmlns}>{aStanza}</pubsub></iq>;
  },

  subscribe : function (aFrom, aTo, aNode) {
    var subscribe = <subscribe node={aNode} jid={aFrom}/>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub, subscribe);
  },

  publish : function(aFrom, aNode, aItem) {
    var aPiece =  <publish node={aNode}>
                    {aItem}
                  </publish>;
    return this.stanza(aFrom, "set", ns_pubsub, aPiece);
  },
  
  unsubscribe : function (aFrom, aTo, aNode) {
    var aPiece = <unsubscribe node={aNode} jid={aFrom}/>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub, aPiece);
  },

  getItem : function (aFrom, aTo, aNode, aId) {
    var stanza =  <items node={aNode}>
                    <item id={aId}/>
                  </items>;
    return this.stanza(aFrom, aTo, "get", ns_pubsub, stanza);
  },
  
  getItems : function (aFrom, aNode) {
    var stanza =  <items node={aNode}>
                  </items>;
    return this.stanza(aFrom, "get", ns_pubsub, stanza);
  },
  
  create : function (aFrom, aTo, aNode) {
    var aPiece =  <create node={aNode}/>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub, aPiece);
  },
  
  deleteNode : function (aFrom, aTo, aNode) {
    var aPiece = <delete node={aNode}/>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub, aPiece);
  },

  configureRequest : function(aFrom, aTo, aNode) {
    var aPiece = <configure node={aNode}/>;
    return this.stanza(aFrom, aTo, "get", ns_pubsub_owner, aPiece);
  },
  
  configure : function(aFrom, aTo, aNode, aConfig) {
    var aPiece =  <configure node={aNode}>
                    {aConfig}
                  </configure>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub_owner, aPiece);
  },

  getAffilitations : function(aFrom, aTo, aNode) {
    var aPiece = <affilitations node={aNode}/>;
    return this.stanza(aFrom, aTo, "get", ns_pubsub, aPiece);
  },
  
  setAffiliations : function(aFrom, aTo, aNode, aAffiliation) {
    var aPiece =  <affiliations node={node}>
                    {aAffiliation}
                  </affiliations>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub_owner, aPiece);
  },

  retract : function(aFrom, aTo, aNode, aId) {
    var aPiece = <retract node={aNode}><item id={aId}/></retract>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub, aPiece);
  },

  purge : function(aFrom, aTo, aNode) {
    var aPiece = <purge node={aNode}/>;
    return this.stanza(aFrom, aTo, "set", ns_pubsub_owner, aPiece);
  }
};
var PEP = {
  publish : function(aFrom, aNode, aItem){
    return pubsub.publish(aFrom, aNode, aItem);
  },
  stop : function(aFrom, aType, aNode) {
    var aItem = <item>
                  <{aType} xmlns={aXmlns}/>.
                </item>;
    return PEP.publish(aFrom, aNode, aItem);
  },
  subscribe : function(aFrom, aTo, aNode) {
    return pubsub.subscribe(aFrom, aTo, aNode);
  }
};
var nick = {
  publish : function(aFrom, aNick) {
    var aItem = <item>
                  <nick xmlns={ns_nick}>{aNick}</nick>
                </item>;
    return PEP.publish(aFrom, ns_nick, aItem);
  },
  stop : function(aFrom) {
    PEP.stop(aFrom, "nick", ns_nick);
  }
};
var geoloc = {
  publish: function(aFrom, aLocation) {
    var aItem = <item>
                  <geoloc/>
                </item>;
    for (item in aLocation) {
      var child = <{item}>{aLocation[item]}</{item}>;
      aItem.geoloc.appendChild(child);
    }
    return PEP.publish(aFrom, ns_geoloc, aItem);
  },
  stop : function(aFrom) {
    PEP.stop(aFrom, "geoloc", ns_geoloc);
  }
};
var XMPPmood = {
  publish : function(aFrom, aText, aMood) {
    var aItem = <item>
                  <mood xmlns={ns_mood}>
                    <{aMood}/>
                    <text>{aText}</text>
                  </mood>
                </item>;
    PEP.publish(aFrom, ns_mood, aItem);
  },
  stop : function(aFrom) {
    PEP.stop(aFrom, "mood", ns_mood);
  }
};
var XMPPtune = {
  publish : function(aFrom, aTune) {
    var aTune = {artist: "toto", rating: "8"};
    var aItem = <item>
                  <tune xmlns={ns_tune}/>
                </item>;
    for each (var item in aTune) {
      //~ var child = <{item.name}>{item}</{item.name};
      //~ aItem..tune.appendChild(child);
    }
    PEP.publish(aFrom, ns_tune, aItem);
  },
  stop : function(aFrom) {
    PEP.stop(aFrom, "tune", ns_tune);
  }
};
var XMPPactivity = {
  publish : function(aFrom, aActivity, aLang) {
    var aItem = <item>
                  <activity xmlns={ns_activity}>
                    <{aActivity[0]}>
                      <{aActivity[1]}/>
                    </{aActivity[0]}>
                    <text xml:lang={aLang}>{aActivity[2]}</text>
                  </activity>
                </item>;
    PEP.publish(aFrom, ns_activity, aItem);
  },
  stop : function(aFrom) {
    PEP.stop(aFrom, "activity", ns_activity);
  }
};
var _avatar = {
  getData : function(aTo, aId) {
    return <iq type='get' to={aTo}>
      <pubsub xmlns='http://jabber.org/protocol/pubsub'>
        <items node='urn:xmpp:avatar:data'>
          <item id={aId}/>
        </items>
      </pubsub>
    </iq>;
  },
  publishMetadata : function(aFrom, aId, aType){
    var aItem = <item id={aId}>
                  <metadata>
                    <info type={aType}/>
                  </metadata>
                </item>;
    return PEP.publish(aFrom, ns_avatar_metadata, aItem);
  },
  publishData : function(aFrom, aId, aData){
    var aItem = <item id={aId}>
                  <data xmlns={ns_avatar_data}>
                    {aData}
                  </data>
                </item>;
    return PEP.publish(aFrom, ns_avatar_data, aItem);
  },
  stop : function(aFrom) {
    PEP.stop(aFrom, "metadata", ns_avatar_metadata);
  }
}
var muc = {
  join : function(aTo, aNick) {
    return  <presence to={aTo + "/" + aNick}/>;
  },
  leave : function(aFrom, aTo) {
    return  <presence from={aFrom} to={aTo} type="unavailable"/>;
  }
};
var roster = {
  remove: function(aTo) {
   return <iq type="set">
            <query xmlns={ns_roster}>
              <item jid={aTo} subscription="remove" />
            </query>
          </iq>;
  },
  add: function(aTo) {
   return <iq type="set">
            <query xmlns={ns_roster}>
              <item jid={aTo}/>
            </query>
          </iq>;
  }
};
